
#ifndef _DAMLDB_TRACE_HH
#define _DAMLDB_TRACE_HH

#if defined (sun)
#  pragma ident "@(#)$Id: Trace.hh,v 1.2 2002/04/09 02:04:46 neves Exp $"
#endif

#include "damldb/Portability.hh"

#if defined(HAVE_LIBLOG4CPP)
#include <log4cpp/Category.hh>
#endif

#include <string>


#if defined(TRACE)
#  define DAMLDB_ERROR(s)	Trace::getInstance()->error(s);
#  define DAMLDB_DEBUG(s)	Trace::getInstance()->debug(s);
#  define DAMLDB_INFO(s)	Trace::getInstance()->info(s);
#  define DAMLDB_WARN(s)	Trace::getInstance()->warn(s);

#  define DAMLDB_ERROR2(s,arg1)	Trace::getInstance()->error(s,arg1);
#  define DAMLDB_DEBUG2(s,arg1)	Trace::getInstance()->debug(s,arg1);
#  define DAMLDB_INFO2(s,arg1)	Trace::getInstance()->info(s,arg1);
#  define DAMLDB_WARN2(s,arg1)	Trace::getInstance()->warn(s,arg1);

#  define DAMLDB_ERROR3(s,arg1,arg2)	Trace::getInstance()->error(s,arg1,arg2);
#  define DAMLDB_DEBUG3(s,arg1,arg2)	Trace::getInstance()->debug(s,arg1,arg2);
#  define DAMLDB_INFO3(s,arg1,arg2)	Trace::getInstance()->info(s,arg1,arg2);
#  define DAMLDB_WARN3(s,arg1,arg2)	Trace::getInstance()->warn(s,arg1,arg2);

#else
#  define DAMLDB_ERROR(s)
#  define DAMLDB_DEBUG(s)
#  define DAMLDB_INFO(s)
#  define DAMLDB_WARN(s)

#  define DAMLDB_ERROR2(s,arg1)
#  define DAMLDB_DEBUG2(s,arg1)
#  define DAMLDB_INFO2(s,arg1)
#  define DAMLDB_WARN2(s,arg1)

#  define DAMLDB_ERROR3(s,arg1,arg2)
#  define DAMLDB_DEBUG3(s,arg1,arg2)
#  define DAMLDB_INFO3(s,arg1,arg2)
#  define DAMLDB_WARN3(s,arg1,arg2)
#endif

#ifdef CCXX_NAMESPACES
namespace damldb {

#if defined(HAVE_LIBLOG4CPP)
USING(log4cpp);
#endif

#endif

  class Trace {
  public:

    ~Trace();

    static Trace * getInstance();

    void error(const char* stringFormat, ...);

    void info(const char* stringFormat, ...);

    void warn(const char* stringFormat, ...);

    void debug(const char* stringFormat, ...);

    void ndc_push(const char* msg);

    void ndc_pop();

  private:
    Trace();

  private:
    static Trace * instance_;
#if defined(HAVE_LIBLOG4CPP)
    Category* root_;
#endif
  };

#ifdef CCXX_NAMESPACES
} // namespace damldb
#endif

#endif //!_DAMLDB_TRACE_HH

// Emacs
// Local Variables:
// mode: c++
// c-basic-offset: 2
// End:
